package lib;

import kernel.peripherals.Screen;

class Rect {
	public final tl:ScreenPos;
	public final br:ScreenPos;

	public function new(p1:ScreenPos, p2:ScreenPos) {
		this.tl = {
			x: MathI.min(p1.x, p2.x),
			y: MathI.min(p1.y, p2.y)
		};

		this.br = {
			x: MathI.max(p1.x, p2.x),
			y: MathI.max(p1.y, p2.y)
		};
	}

	public function getSize():Int {
		return getWidth() * getHight();
	}

	public function isInside(p:ScreenPos):Bool {
		return (p.x >= tl.x && p.x <= br.x) && (p.y >= tl.y && p.y <= br.y);
	}

	public function isOutside(p:ScreenPos):Bool {
		return !this.isInside(p);
	}

	public function getHight():Int {
		return br.y - tl.y;
	}

	public function getWidth():Int {
		return br.x - tl.x;
	}

	public function offset(pos:ScreenPos) {
		tl.x += pos.x;
		tl.y += pos.y;
		br.x += pos.x;
		br.y += pos.y;
	}
}
